/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

WL.Server.createEventSource({
	name : 'mysuranceEventSource',
	onDeviceSubscribe : 'deviceSubscribeFunc',
	onDeviceUnsubscribe : 'deviceUnsubscribeFunc',
	securityTest:'mysurance-strong-mobile-securityTest'
});

function deviceSubscribeFunc(userSubscription, deviceSubscription) {
	WL.Logger.debug(">> deviceSubscribeFunc");
}

function deviceUnsubscribeFunc(userSubscription, deviceSubscription) {
	WL.Logger.debug(">> deviceUnsubscribeFunc");
}

function submitNotification(notificationText) {
	var activeUser = WL.Server.getActiveUser();
	var userId = activeUser.userId;

	if (!notificationText) {
		notificationText = "auto";
	}

	var userSubscription = WL.Server.getUserNotificationSubscription(
			'mysuranceAdapter.mysuranceEventSource', userId);

	if (userSubscription == null) {
		WL.Logger.debug("No subscription found for user :: " + userId);
		return;
	}

	WL.Logger.debug("submitNotification >> userId :: " + userId + ", text :: "
			+ notificationText);

	WL.Server.notifyAllDevices(userSubscription, {
		badge : 1,
		sound : "",
		activateButtonLabel : "ClickMe",
		alert : notificationText,
		payload : {
			foo : 'bar'
		}
	});
}

function sendNotificationOTA(userId, notificationText, accId) {
	if (!userId)
		userId = "DD";

	if (!notificationText) {
		notificationText = "auto";
	}
	
	if (!accId) {
		accId = -1;
	}

	var userSubscription = WL.Server.getUserNotificationSubscription(
			'mysuranceAdapter.mysuranceEventSource', userId);

	if (userSubscription == null) {
		WL.Logger.debug("No subscription found for user :: " + userId);
		return;
	}

	WL.Logger.debug("sendNotificationOTA >> userId :: " + userId + ", text :: "
			+ notificationText);

	WL.Server.notifyAllDevices(userSubscription, {
		badge : 1,
		sound : "",
		activateButtonLabel : "ClickMe",
		alert : notificationText,
		payload : {
			accId : accId
		}
	});
}
