/*
*  Licensed Materials - Property of IBM
*  5725-G92 (C) Copyright IBM Corp. 2006, 2013. All Rights Reserved.
*  US Government Users Restricted Rights - Use, duplication or
*  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

var pushAppRealmChallengeHandler = WL.Client.createChallengeHandler("PushAppRealm");

pushAppRealmChallengeHandler.isCustomResponse = function(response) {
    if (!response || response.responseText === null) {
        return false;
    }
    var indicatorIdx = response.responseText.search('j_security_check');
    
    if (indicatorIdx >= 0){
		return true;
	}  
	return false;
};

pushAppRealmChallengeHandler.handleChallenge = function(response) {
	if(firstlogin){
		$('#AppBody').hide();
		$('#AuthBody').show();
		//$('#passwordInputField').val('');
	}else{
		WL.Client.init({});
	    pushAppRealmChallengeHandler.submitLoginForm('/j_security_check', {parameters:{
	        j_username : window.userName,
	        j_password : window.password
	    }}, pushAppRealmChallengeHandler.submitLoginFormCallback);
	}
};

pushAppRealmChallengeHandler.submitLoginFormCallback = function(response) {
    var isLoginFormResponse = pushAppRealmChallengeHandler.isCustomResponse(response);
    if (isLoginFormResponse){
    	alert('Invalid username or password!');
    	pushAppRealmChallengeHandler.handleChallenge(response);
    } else {
    	firstlogin = false;
    	window.userName = $('#usernameInputField').val();
    	writeCache(window.userName, $('#passwordInputField').val());
		$('#AppBody').show();
		$('#AuthBody').hide();
		pushAppRealmChallengeHandler.submitSuccess();
		//alert("Online login success: " + window.userName);
    }
};

$('#loginButton').bind('click', function () {
	
	var username = $('#usernameInputField').val();
	var password = $('#passwordInputField').val();
	
	if(!username || !password) {
		alert("username or password is null!");
        return;
	}
	
	WL.Device.getNetworkInfo(function(netInfo) {
		if(netInfo.isNetworkConnected == 'false') {
			window.connected = false;
			readCache(username, function(cachedPassword) {
				if(password != cachedPassword) {
					alert('Invalid username or password!');
				} else {
					//alert("offline auth success!");
					firstlogin = false;
					window.userName = username;
					window.password = password;
					wlCommonInit();
					$('#AppBody').show();
					$('#AuthBody').hide();
					alert("You are in offline mode now, most feature are not supported in this mode.");
				}
			});
		} else {
			window.connected = true;
		    var reqURL = '/j_security_check';
		    var options = {};
		    options.parameters = {
		        j_username : username,
		        j_password : password
		    };
		    options.headers = {};
		    pushAppRealmChallengeHandler.submitLoginForm(reqURL, options, pushAppRealmChallengeHandler.submitLoginFormCallback);
		}
	});
	
});

window.busy = new WL.BusyIndicator();
var openCacheFailure = function(status) {
	alert('Open Encrypted Cache failed: ' + status);
	busy.hide();
};

window.writeCache = function(key, value, onSuccess) {
	WL.EncryptedCache.open('ENCRYPT_KEY', true, function(status) {
		WL.EncryptedCache.write(key, value, function() {
			if(onSuccess && $.isFunction(onSuccess)) {
				onSuccess();
			}
			WL.EncryptedCache.close(function() {
				busy.hide();
			});
		}, function(status) {
			alert("Write Encrypted Cache failed. error code= " + status);
		});
	}, openCacheFailure);
};

window.readCache = function(key, onSuccess) {
	busy.show();
	WL.EncryptedCache.open('ENCRYPT_KEY', true, function(status) {
		WL.EncryptedCache.read(key, function(value) {
			if(onSuccess && $.isFunction(onSuccess)) {
				onSuccess(value);
			}
			WL.EncryptedCache.close(function() {
				busy.hide();
			});
		}, function(status) {
			alert("Read Encrypted Cache failed. error code= " + status);
		});
	}, openCacheFailure);
};
