/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

// Worklight comes with the jQuery framework bundled inside. If you do not want to use it, please comment out the line below.
window.$ = WLJQ;
window.modelInstance = null;
window.connected = true;
window.firstlogin = true;
window.commonControlInit = false;

var globalBusy = null;

var currentAcc = {};
var currentDetail = {};
var photoList={};
var allAcc = localStorage.getItem("allAcc")? JSON.parse(localStorage.getItem("allAcc")) : [];
var serverAddress = localStorage.getItem("serverAddress");
var subscribeStatus = localStorage.getItem("subscribeStatus")?localStorage.getItem("subscribeStatus"):"off";
//alert(JSON.stringify(allAcc));

[].indexOf || (Array.prototype.indexOf = function(v){
	for(var i = this.length; i-- && this[i] !== v;);
	return i;
});

Date.prototype.format = function(format) {
    var o = {
    	"M+" : this.getMonth()+1, //month
    	"d+" : this.getDate(),    //day
    	"h+" : this.getHours(),   //hour
    	"m+" : this.getMinutes(), //minute
    	"s+" : this.getSeconds(), //second
    	"q+" : Math.floor((this.getMonth()+3)/3),  //quarter
    	"S" : this.getMilliseconds() //millisecond
    };
    if(/(y+)/.test(format)) {
    	format=format.replace(RegExp.$1,
    		(this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
	for(var k in o) {
		if(new RegExp("("+ k +")").test(format)) {
			format = format.replace(RegExp.$1, 
				RegExp.$1.length==1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
};

function initDataSyncModel(){
	var mySCHEMA = {"fn":"string","ln":"string","username":"string","id":"string"};
	var myCOLLECTION = 'profile';
	
	var myLoad = {
			procedure: 'getProfile',
			params: ['{"username":"' + window.userName + '"}'],
			key: "profile"
		};

	var initCollectionSuccessCallback = function () {
		WL.Logger.debug('WL.profile initCollectionSuccessCallback');
		modelInstance.find({"username": window.userName}, {onSuccess: findSucc, onFailure: fail});
		};
		
	var findSucc = function(data){
		//alert(JSON.stringify(data));
		var item = data[0];
		document.getElementById("license").value = item.json.id;
		document.getElementById("firstname").value = item.json.fn;
		document.getElementById("lastname").value = item.json.ln;
		document.getElementById("birthday").value = item.json.birthday;
	};

	var myModelOpts = {
		onSuccess: initCollectionSuccessCallback,
		onFailure: fail,
		adapter:
		{	name: "ProfileAdapter",
			replace: "updateProfile",
			remove: "removeProfile",
			add:"addProfile",
			load: myLoad
		},
		load:true
    };

	modelInstance = WL.JSONStore.initCollection(myCOLLECTION, mySCHEMA, myModelOpts);
}

function wlCommonInit(){
	// Common initialization code goes here
	WL.Logger.debug("Mysurance.js: in wlCommonInit()");
	if(!commonControlInit){
		initCommonControls();
		initDataSyncModel();
		// Initialize a generic busy indicator
		globalBusy = new WL.BusyIndicator('content', { text: 'Loading...'} );
		document.addEventListener(WL.Events.WORKLIGHT_IS_CONNECTED, connectDetected, false); 
		document.addEventListener(WL.Events.WORKLIGHT_IS_DISCONNECTED, disconnectDetected , false);
		WL.Client.setHeartBeatInterval(5);
	
		// Load required Dojo Mobile modules
		require(
				// Set of module identifiers
				[ "dojo", "dojo/dom","mysurance/common","dijit/registry","dojo/_base/connect","dojox/mobile/parser", "dojox/mobile",
						"dojox/mobile/View",
						"dojox/mobile/Heading", "dojox/mobile/RoundRectList",
						"dojox/mobile/ListItem", "dojox/mobile/ScrollableView",
						"dojox/mobile/TextBox",	"dojox/mobile/TabBar",
						"dojox/mobile/RoundRectCategory", "dojox/mobile/EdgeToEdgeList",
						"dojox/mobile/Button", "dojox/mobile/ToolBarButton",
						"dojox/mobile/IconContainer", "dojox/mobile/IconItem",
						"mysurance/controllers/profileController", 
						"mysurance/widgets/GoogleMap" ],
				function(dojo,dom,common,registry,connect) {
					hideLoader();
					// This method is executed after the Dojo modules above have been loaded but before the parser has processed the HTML
					WL.Logger.debug("Mysurance.js: in function(dojo)");
					dojo.ready(function() {
						// This method is executed after the DOM has been setup and Dojo widgets are instantiated
						WL.Logger.debug("Mysurance.js: in dojo.ready(function())");
						
						var list = registry.byId("accList");
						//alert(JSON.stringify(allAcc));
						for(var i=0;i<allAcc.length;i++){
							var listitem = new dojox.mobile.ListItem({id:allAcc[i].id ,icon:'images/delete1.png',style:"text-align:left",label: allAcc[i].locationInfo.city+","+
								allAcc[i].locationInfo.street+ '<br>'+ allAcc[i].otherDriver.firstname+" "+ allAcc[i].otherDriver.lastName + '<br>' + allAcc[i].date +
								'<br>'+'<img id="statusImg'+ allAcc[i].id +'" src="images/icons/pending.png"/><span id="statusText'+ allAcc[i].id +'"><font color="red" size="2">Pending</font></span>',variableHeight:true,clickable:true});
							list.addChild(listitem);
							
							dojo.query('.mblListItemIcon',listitem.domNode).onclick(function(e){
								e.stopPropagation();
								var delId = this.parentElement.parentElement.id;
								common.localConfirm("Do you want to delete this item?",function(){
									for(var i=0;i<allAcc.length;i++){  
										 if(allAcc[i].id == delId){
											 allAcc.splice(allAcc.indexOf(allAcc[i]), 1);
										 }
									 }
									//alert(dojo.toJson(allAcc));
									localStorage.setItem("allAcc",JSON.stringify(allAcc));
									dojo.query("#" + delId).forEach(function(node){
										dojo.destroy(node);
									}); 
								});
							}); 
							
							dojo.query("#" + listitem.id).onclick(function(e){
								 for(var i=0;i<allAcc.length;i++){  
									 if(allAcc[i].id == this.id){
										//alert(dojo.toJson(allAcc[i]));
										currentDetail = allAcc[i];
										common.loadAndTransitView(	{
											pageUrl: "js/mysurance/views/viewPhoto.html",
											module: "mysurance/module/viewPhoto",
											targetView: "viewPhoto",
											transition: "slide"
										});
									 }
								 }
							});
						}
						
						common.registerOnclickHandler("firstAid");
						common.registerOnclickHandler("addAccBtn");
						common.registerOnclickHandler("findTruck");
						common.registerOnclickHandler("settings"); 
					});
				}
		);	
		 WL.App.overrideBackButton(backKeyDownFunction);
	}
}

// Hides the loader overlay defined in Mysurance.html
function hideLoader(){
    dojo.fadeOut({
        node:"loader",
        onEnd: function(){
            dojo.style("loader", "display", "none");
        }
    }).play();
    document.getElementById("mainView").style.display = "";
}

// In case server is not available don't fail but run in disconnected mode instead
function doConnectionFailure(){
	WL.Logger.debug("Mysurance.js: Worklight server unavailable, running in disconnected mode.");
	wlCommonInit();
}

function backKeyDownFunction(){
	
	var cView = dojox.mobile.currentView;
	WL.Logger.debug("WL.App.overrideBackButton-backKey pressed on view: "+ cView.id);
	switch (cView.id)
	{
	case "profileView":
//		WL.Logger.debug("Profile View - back");
		cView.performTransition('mainView',1,"slide",null);
		break;
	case "toolboxView":
//		WL.Logger.debug("Accident Toolbox View - back");
		cView.performTransition('mainView',1,"slide",null);
		break;	
	case "locationView":
//		WL.Logger.debug("Location View - back");
		cView.performTransition('toolboxView',-1,"slide",null);
		break;
	case "photosView":
//		WL.Logger.debug("Photo View - back");
		cView.performTransition('otherDriverView',-1,"slide",null);
		break;
	case "otherDriverView":
//		WL.Logger.debug("Other Driver View - back");
		cView.performTransition('locationView',-1,"slide",null);
		break;
	case "helpView":
//		WL.Logger.debug("Help View - back");
		cView.performTransition('mainView',1,"slide",null);
		break;
	case "towingMapView":
//		WL.Logger.debug("Towing Map View - back");
		cView.performTransition('helpView',-1,"slide",null);
		break;
	case "firstAidView":
//		WL.Logger.debug("First Aid View - back");
		cView.performTransition('helpView',-1,"slide",null);
		break;
	case "appSettings":
//		WL.Logger.debug("Server Config View - back");
		cView.performTransition('helpView',-1,"slide",null);
		break;
	case "viewPhoto":
//		WL.Logger.debug("First Aid View - back");
		cView.performTransition('toolboxView',-1,"slide",null);
		break;
	default:
		WL.Logger.debug("Default - exit");
		navigator.app.exitApp();		
		return;	
	}
		
}

//---------------------------- Set up push notifications -------------------------------
WL.Client.Push.onReadyToSubscribe = function(){
	//alert("onReadyToSubscribe");
	WL.Client.Push.registerEventSourceCallback(
			"mysurancePush", 
			"mysuranceAdapter", 
			"mysuranceEventSource", 
			pushNotificationReceived);
};

//------------------------------- Handle received notification ---------------------------------------
function pushNotificationReceived(props, payload){
	//alert("pushNotificationReceived invoked");
	if(typeof(props.alert.body)!="undefined"){
		//for iOS
		alert(props.alert.body);
	}else{
		alert(props.alert);
	}
	updateStatus(payload.accId);
}

function updateStatus(accId){
	var statusEle = dojo.byId("statusImg"+accId);
	var statusText = dojo.byId("statusText"+accId);
	if(statusEle && statusText){
		statusEle.src = "images/icons/done.png";
		statusText.innerHTML = '<font color="green" size="2">Approved</font>';
	}
}

/* JavaScript content from js/mysurance.js in folder android */
// This method is invoked after loading the main HTML and successful initialization of the Worklight runtime.
function wlEnvInit(){
    wlCommonInit();
    // Environment initialization code goes here
}

function disconnectDetected(){
	window.connected = false;
	alert("Disconnect detected, will use local database to save app data.");
}

function connectDetected(){
	window.connected = true;
	modelInstance.getPushRequired({onSuccess:function(data) {
		if(data.length > 0){
			//alert("These data are out of sync: " + JSON.stringify(data));
			 var r=confirm("Connect detected, your profile data is out of sync. Do you want to sync now?");
			  if (r == true) {
				  dojo.getObject("mysurance.profileController").syncData();
			  } else {
				  return;
			  }
		}
	}, onFailure: fail});
}

function fail(data){
	alert("failed with data: " + data);
}

