/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define(["dojo/dom","dojo/dom-construct","dojo/_base/window", "dojo/_base/connect", "dojo/_base/array","dojo/_base/xhr","dojo/has","dojo/on","dojo/ready","dijit/registry","dojox/mobile/parser","dojox/mobile/TransitionEvent"], 
function(dom,domConstruct,win,connect,array,xhr,has,on,ready,registry,parser,TransitionEvent) {

	isModuleInit = {};
	
	function noServerAddressPrompt() {
		navigator.notification.confirm("Mysurance has not yet\nconnected to a server.", function(buttonIndex) {
			if(buttonIndex == 1) {
				if (dijit.byId("appSettings")) {
						new TransitionEvent(document.body, {moveTo : "appSettings",transition : "slide"}).dispatch();
					return;
				}else{
					loadAndTransitView({
						pageUrl: "js/mysurance/views/serviceConfig.html",
						module: "mysurance/module/serviceConfig",
						targetView: "appSettings",
						transition: "slide"
					});
				}
			}
		}, "Unable to Connect", "Connect, Cancel");
	}
	
	function registerOnclickHandler(id){
		var node = dom.byId(id);
	
		node.pageurl = node.getAttribute("pageurl");
		node.module = node.getAttribute("module");
		node.targetView = node.getAttribute("targetView");
		node.transition = node.getAttribute("transition");
		
		on(node, "click", function(){
			loadAndTransitView({
				pageUrl: node.pageurl,
				module: node.module,
				targetView: node.targetView,
				transition: node.transition
			}); 
		});		
	}
	
	function loadAndTransitView(opt){
		if (registry.byId(opt.targetView)) {
			if("viewPhoto"==opt.targetView){
				dojo.getObject("mysurance.viewPhoto").init();
			}
			new TransitionEvent(document.body,{moveTo:opt.targetView,transition:opt.transition}).dispatch();
			return;
		};
		// load the page
		var defer = xhr.get({
			url: opt.pageUrl,
			handleAs: "text",
			//preventCache: true,
			sync: true
		});
		if (opt.module) {
			// initialize module, parse, and transit
			defer.then(function (text){
				parseHtml(text);
				// initialize module
				require([opt.module], function(module){
					if (module && module.init  && !isModuleInit[opt.module]){
						module.init();
						if("mysurance/module/viewPhoto"!=opt.module){
							isModuleInit[opt.module] = true;
						}
					}
					new TransitionEvent(document.body,{moveTo:opt.targetView,transition:opt.transition}).dispatch();
				});
			}, function(err){alert(err);});
		}else{
			// parse, transit
			defer.then(function(text){
				parseHtml(text);
				new TransitionEvent(document.body,{moveTo:opt.targetView,transition:opt.transition}).dispatch();
			}, function(err){alert(err);});
		}
	}
	
	function parseHtml(text){
		var tmpContainer = domConstruct.create("DIV");
		tmpContainer.innerHTML = text;
		var body = win.body();
		body.appendChild(tmpContainer);
		var ws = parser.parse(tmpContainer);
		array.forEach(ws, function(w){
			if(w && !w._started && w.startup){
				w.startup();
			}
		});
		body.removeChild(tmpContainer);
		for (var i = 0; i < tmpContainer.childNodes.length; i ++) {
			//body.appendChild(tmpContainer.childNodes[i]);
			dom.byId("AppBody").appendChild(tmpContainer.childNodes[i]);
		}
	}
	
	function localConfirm(msg,callback){
		var question = window.confirm(msg); 
		if (question){
			callback();
		}
	}
	
	function isConnect(){
		return window.connected;
	}
	
	var common = {noServerAddressPrompt:noServerAddressPrompt,registerOnclickHandler:registerOnclickHandler, loadAndTransitView:loadAndTransitView,localConfirm:localConfirm,isConnect:isConnect};
	return common;
});