/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define(["dojo/dom","dojo/dom-construct","dojo/_base/window", "dojo/_base/connect", "dojo/_base/array","dojo/_base/xhr","dojo/has","dojo/on","dojo/ready","dijit/registry","dojox/mobile/parser","dojox/mobile/TransitionEvent","mysurance/common"], 
function(dom,domConstruct,win,connect,array,xhr,has,on,ready,registry,parser,TransitionEvent,common) {

	var profileController = dojo.getObject("mysurance.profileController",true);
	
	profileController.getProfile = function(userName){
		var parameter = '{"username":"' + window.userName + '"}';
		if(common.isConnect()){
			var invocationData = {
					adapter : 'ProfileAdapter',
					procedure : 'getProfile',
					parameters : [parameter],
			};
			WL.Client.invokeProcedure(invocationData, {
				onSuccess : function (data) {
					if (data.invocationResult.profile.id) {
						//alert(JSON.stringify(data.invocationResult));
						dom.byId("license").value = data.invocationResult.profile.id;
						dom.byId("firstname").value = data.invocationResult.profile.fn;
						dom.byId("lastname").value = data.invocationResult.profile.ln;
						dom.byId("birthday").value = data.invocationResult.profile.birthday;
					} else {
						alert("No available profile found, please input the correct license number.");
					}
				},
				onFailure : function (data) {
					alert("invokeProcedure failed with data: " + JSON.stringify(data));
				}
			});
		}else{
			alert("Can not get user info offline.");
		}
	};
	
	profileController.updateProfile = function(){
		modelInstance.find({"username": window.userName }, {onSuccess: findSucc, onFailure: fail});
	};
	
	function findSucc(data){
		if(0 == data.length){
			alert("No available profile found, please input the correct license number.");
		}else{
			//alert(JSON.stringify(data));
			var item = data[0];
			item.json.id =  dom.byId("license").value;
			item.json.fn =  dom.byId("firstname").value;
			item.json.ln =  dom.byId("lastname").value;
			item.json.birthday =  dom.byId("birthday").value;
			modelInstance.replace(item, {onSuccess: finishedReplaceSuccesfully, onFailure: fail});
		}
	}
	
	function find(userName){
		modelInstance.find({"username": userName}, {onSuccess: findSucc, onFailure: fail});
	}
	
	function fail(data){
		alert("failed with data: " + data);
	}
	
	function finishedReplaceSuccesfully(data) {
		//alert(data + ' document modified');
		if(common.isConnect()){
			modelInstance.getPushRequired({onSuccess:function(data) {
				if(data.length > 0){
					dojo.getObject("mysurance.profileController").syncData();
				}
			}, onFailure: fail});
		}else{
			alert("Save to local database, will sync to server side when connected again.");
		}
	}
	
	profileController.syncData = function(){
		modelInstance.push({onSuccess:function(data) {
			alert("Pofile update successfully!");
		}, onFailure: fail});
	};
	
});