/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define(["dojo/dom","dojo/dom-construct","dojo/_base/window", "dojo/_base/connect", "dojo/_base/array","dojo/_base/xhr","dojo/has","dojo/on","dojo/ready","dijit/registry","dojox/mobile/parser","dojox/mobile/TransitionEvent","mysurance/common"], 
function(dom,domConstruct,win,connect,array,xhr,has,on,ready,registry,parser,TransitionEvent,common) {

	var location = dojo.getObject("mysurance.location",true);
	
	location.locationInfo = {
		"street" : "",
		"city" : "",
		"state" : "",
		"zip" : ""
	};
	
	location.readForm = function(){
		// Get values from form
		location.locationInfo.street = dom.byId("street").value;
		location.locationInfo.city = dom.byId("city").value;
		location.locationInfo.state = dom.byId("state").value;
		location.locationInfo.zip = dom.byId("zip").value;
		//localStorage.setItem("location", JSON.stringify(location.locationInfo));
	};
	
	location.loadLocation = function() {
		var locationTmp = localStorage.getItem("location"); // Get accident info from local storage
		if (locationTmp == null) {
			WL.Logger.debug("No location info in localStorage, using defaults");
			locationTmp = location.locationInfo;
		} else {
			WL.Logger.debug("Location info read from localStorage");
			locationTmp = JSON.parse(locationTmp); // Convert from string into JSON object
		}
		location.locationInfo=locationTmp;
		WL.Logger.debug("Location info is "+JSON.stringify(this.location));
		this.populateForm();
	};
	
	location.populateForm = function() {
		dom.byId("street").value= location.locationInfo.street;
		dom.byId("city").value= location.locationInfo.city;
		dom.byId("state").value= location.locationInfo.state;
		dom.byId("zip").value= location.locationInfo.zip;
	};
	
	location.onLocationButtonClicked = function(e) {
		getLocation(this.reverseGeocode); // After location found, call reverseGeocode
	};
	
	location.reverseGeocode = function(loc) {
		
		geocoder = new google.maps.Geocoder();
		geocoder.geocode({'latLng':loc}, function(results, status){
			if(status == google.maps.GeocoderStatus.OK){
				var streetNum = '';
				var street = '';
				var city = '';
				var state = '';
				var zip = '';
				var a = results[0].address_components;
				for (var i in a) {
					var l = a[i];
					if (l.types) {
						WL.Logger.debug("AccidentLocationController.reverseGeocode() l="+l.types[0]+",  "+l.long_name);
						if (l.types[0] == 'street_number') {
							streetNum = l.long_name;
						}
						if (l.types[0] == 'route') {
							street = l.long_name;
						}
						if (l.types[0] == 'locality' || l.types[0] == 'postal_town') {
							city = l.long_name;
						}
						if (l.types[0] == 'administrative_area_level_1') {
							state = l.short_name;
						}
						if (l.types[0] == 'postal_code') {
							zip = l.long_name;
						}
					}
				}
					
				// Because of the complicated call structure with nested callbacks and functions
				// we just pass the variables back using the location form in the DOM, for simplicity.
				dom.byId("street").value = streetNum + (streetNum != "" ? " " : "") + street;
				dom.byId("city").value = city;
				dom.byId("state").value = state;
				dom.byId("zip").value = zip;

			} else {
				dom.byId("street").value = "";
				dom.byId("city").value = "";
				dom.byId("state").value = "";
				dom.byId("zip").value = "";
			}			
		});
	};
	
	location.next = function(){
		this.readForm();
		currentAcc.locationInfo = this.locationInfo;
		common.loadAndTransitView(	{
			pageUrl: "js/mysurance/views/accOther.html",
			module: "mysurance/module/accOther",
			targetView: "otherDriverView",
			transition: "slide"
		});
	};
	
	function init(){
		console.log("Initialize location");
	}

	return {init:init};
});