/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define(["dojo/dom","dojo/dom-construct","dojo/_base/window", "dojo/_base/connect", "dojo/_base/array","dojo/_base/xhr","dojo/has","dojo/on","dojo/ready","dijit/registry","dojox/mobile/parser","dojox/mobile/TransitionEvent","mysurance/common"], 
function(dom,domConstruct,win,connect,array,xhr,has,on,ready,registry,parser,TransitionEvent,common) {

	var photo = dojo.getObject("mysurance.photo",true);
	photo.id = 0;
	photo.photoInfo = {};
	
	//Work around for android 4.1 uploading issue
	var curUploadAccId = null;
	var curUploadPhoId = null;
	var curUploadImageURL = null;

	photo.takePhoto = function(id) {
		photo.id = id;
		if(navigator.camera){
			navigator.camera.getPicture(photoSuccess, photoError, {
				quality : 20,
				destinationType : Camera.DestinationType.FILE_URI
			});
		}else{
			alert("Not support camera!");
		}
	};

	function photoSuccess(imageData) {
		console.log("photoSuccess() for photo" );
		photo.photoInfo[photo.id] = imageData;
		var accId = parseInt(localStorage.getItem("count")?localStorage.getItem("count") : "0") + 1; 
		var photoName = "acc" + accId +"pho" + photo.id;
		photoList[photoName]=imageData;
		dojo.getObject("mysurance.photo").displayPhoto(photo.id, imageData);
	};
	
	photoError = function(error) {
		console.log("photoError() for photo id " + this.photoId + ": " + error);
	};

	photo.displayPhoto = function(id, imageData) {
		var el = document.getElementById("photo" + id + "-text");
		if (imageData) {
			el.style.visibility = 'hidden';
			el.style.display = 'none';
		} else {
			el.style.visibility = 'visible';
			el.style.display = 'block';
		}

		var img = document.getElementById("photo" + id);
		if (imageData) {
			img.style.height = "150px";
			img.style.visibility = 'visible';
			img.style.display = 'block';
			img.src = imageData;
		} else {
			img.style.height = "150px";
			img.style.visibility = 'hidden';
			img.style.display = 'none';
			img.src = "";
		}
	};
	
	
	photo.submit = function(){
		
		if(!common.isConnect()){
			alert("can not perform this action in offline mode.");
			return;
		}
		
		if (!serverAddress) {
			common.noServerAddressPrompt();
			return;
		}
		
		globalBusy = new WL.BusyIndicator('content', { text: 'Submitting...'} );
		if(!globalBusy.isVisible()){
			globalBusy.show();
		}
		
		currentAcc.photoInfo = this.photoInfo;
		var count = localStorage.getItem("count")?localStorage.getItem("count") : "0"; 
		currentAcc.id = parseInt(count) + 1;
		localStorage.setItem("count",currentAcc.id);
		
		var fullTime = new Date().format("yyyy-MM-dd hh:mm:ss");
		currentAcc.date = fullTime;
		var street = dom.byId("street").value;
		var city = dom.byId("city").value;
		var firstName = dom.byId("firstnameOtherDriver").value;
		var lastName = dom.byId("lastnameOtherDriver").value;
		
		var list = registry.byId("accList");
		var listitem = new dojox.mobile.ListItem({id:currentAcc.id ,icon:'images/delete1.png',style:"text-align:left",label: city+","+street+ '<br>'+ 
			firstName+" "+lastName+'<br>'+fullTime + '<br>'+'<img id="statusImg'+ currentAcc.id +'" src="images/icons/pending.png"/><span id="statusText'+ currentAcc.id +
			'"><font color="red" size="2">Pending</font></span>',variableHeight:true,clickable:true});
		list.addChild(listitem);
		
		dojo.query('.mblListItemIcon',listitem.domNode).onclick(function(e){
			e.stopPropagation();
			var delId = this.parentElement.parentElement.id;
			
			common.localConfirm("Do you want to delete this item?",function(){
				for(var i=0;i<allAcc.length;i++){  
					 if(allAcc[i].id == delId){
						 allAcc.splice(allAcc.indexOf(allAcc[i]), 1);
					 }
				 }
				//alert(dojo.toJson(allAcc));
				localStorage.setItem("allAcc",JSON.stringify(allAcc));
				dojo.destroy(listitem.domNode);
			});
		}); 
		
		dojo.query("#" + listitem.id).onclick(function(e){
			 for(var i=0;i<allAcc.length;i++){  
				 if(allAcc[i].id == this.id){
					currentDetail = allAcc[i];
					//alert(dojo.toJson(currentDetail));
					common.loadAndTransitView(	{
						pageUrl: "js/mysurance/views/viewPhoto.html",
						module: "mysurance/module/viewPhoto",
						targetView: "viewPhoto",
						transition: "slide"
					});
				 }
			 }
		});
		//deep copy
		allAcc.push(JSON.parse(JSON.stringify(currentAcc)));
		//alert(dojo.toJson(allAcc));
		
		var data = dojo.toJson({
			user: window.userName,
			id:currentAcc.id,
			crash:currentAcc.photoInfo[0]?"acc" + currentAcc.id + "pho0.jpg":"null",
			ycar:currentAcc.photoInfo[1]?"acc" + currentAcc.id + "pho1.jpg":"null",
			ocar:currentAcc.photoInfo[2]?"acc" + currentAcc.id + "pho2.jpg":"null",
			license:currentAcc.photoInfo[3]?"acc" + currentAcc.id + "pho3.jpg":"null"
		});
		
		//alert(data);
		dojo.xhrPost({
			url: "http://" + serverAddress + "/mysurance/rest/accident",
			//handleAs: "json",
			headers:{"Content-Type":"application/json"},
			postData: data,
			load: function(res){
				var resObject = dojo.fromJson(res);
				var uploadAcc;
				var isPhotoEmpty = true;
				if("success" == resObject.status){
					for(var i=0;i<allAcc.length;i++){  
						 if(allAcc[i].id == resObject.accId){
							 uploadAcc = allAcc[i];
							 break;
						 }
					 }
					if(uploadAcc){
						for(var i=0;i<4;i++){
							if(uploadAcc.photoInfo[i]){
								isPhotoEmpty = false;
								uploadPhoto(uploadAcc.id,i,uploadAcc.photoInfo[i]);
								break;
							}
						}
						if(isPhotoEmpty){
							globalBusy.hide();
							alert("No photo to upload. Accident information has been submited to the server!");
							dojox.mobile.currentView.performTransition('toolboxView',1,"slide",null);
						}
					}
				}else{
					globalBusy.hide();
					alert("error occured when resolving response.");
				}
			},
			error: function(error){
				globalBusy.hide();
				alert("error occured when submitting request.");
				alert(dojo.toJson(error));
			}
		});
		
		currentAcc = {};
		this.photoInfo = {};
		localStorage.setItem("allAcc",JSON.stringify(allAcc));
	};
	
	function uploadPhoto(accId,phoId,imageURL) {
		curUploadAccId = accId;
		curUploadPhoId = phoId;
		curUploadImageURL = imageURL;
		//alert("uploading: "+accId+"_"+phoId+"_"+imageURL);
		if(!globalBusy.isVisible()){
			globalBusy.show();
		}
		var options = new FileUploadOptions();
		options.fileKey = "file";
		options.fileName = "acc" + accId +"pho" + phoId + ".jpg";
		options.mimeType = "image/jpeg";
		options.chunkedMode = false;

		var ft = new FileTransfer();
		ft.upload(imageURL, "http://" + serverAddress
				+ "/mysurance/rest/upload", uploadSuccess,
				uploadError, options);
		
	}

	function uploadSuccess(data) {
		var accId = parseInt(data.response.substring(data.response.indexOf("acc") + 3,data.response.indexOf("pho")));
		var phoId = parseInt(data.response.substring(data.response.indexOf("pho") + 3,data.response.indexOf(".jpg")));
		var nextPhoto = findNextPhoto(accId , phoId);
		if(nextPhoto != null){
			uploadPhoto(nextPhoto.accId,nextPhoto.phoId,nextPhoto.imageURL);
		}else{
			globalBusy.hide();
			console.log("Accident information has been submited to the server!");
			navigator.notification.alert("Accident information has been submited to the server!");
			for(var i=0;i<4;i++){
				img = dom.byId("photo" + i);
				img.style.visibility = 'hidden';
				img.style.display = 'none';
				img.src = '';
				var photoText = dom.byId("photo" + i + "-text");
				photoText.style.visibility = 'visible';
				photoText.style.display = 'block';
			}
			dojox.mobile.currentView.performTransition('toolboxView',1,"slide",null);
		}
	}

	function uploadError(error) {
		console.log("uploadError() for photo: " + error);
		//Work around for android 4.1 uploading issue
		if((3 == error.code)&&("4.1" == device.version.substring(0,3))){
			uploadPhoto(curUploadAccId,curUploadPhoId,curUploadImageURL);
		}else{
			navigator.notification.alert("Error uploading photo: " + dojo.toJson(error));
		}
	}
	
	function findNextPhoto(accId, phoId){
		if(phoId < 3){
			var key = "acc" + accId +"pho" + (phoId + 1);
			if(photoList[key]){
				return {"accId":accId,"phoId":phoId+1,"imageURL":photoList[key]};
			}else{
				return findNextPhoto(accId,phoId+1);
			}
		}else{
			return null;
		}
	}

	function init(){
		console.log("Initialize photo");
	}

	return {init:init};
});