/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

define(["dojo/dom", "dojo/dom-construct", "dojo/_base/window", "dojo/_base/connect", "dojo/_base/array", "dojo/_base/xhr", "dojo/has", "dojo/on", "dojo/ready", "dijit/registry", "dojox/mobile/parser", "dojox/mobile/TransitionEvent", "mysurance/common"],
function(dom, domConstruct, win, connect, array, xhr, has, on, ready, registry, parser, TransitionEvent, common) {

    var viewPhoto = dojo.getObject("mysurance.viewPhoto", true);

    viewPhoto.ok = function() {
        dojox.mobile.currentView.performTransition('toolboxView', -1, "slide", null);
    };

    viewPhoto.init = function() {
        var shortEdge = window.innerHeight < window.innerWidth ? window.innerHeight:window.innerWidth;
        var showimgNode = dom.byId("showimg");
        showimgNode.style.height = shortEdge / 2 + "px";
        showimgNode.style.width = shortEdge / 1.5 + "px";
        showimgNode.style.marginTop = 50 + "px";

        var imgsrc = new Array();
        imgsrc[0] = currentDetail.photoInfo["0"]?currentDetail.photoInfo["0"]:"images/empty.png";
        imgsrc[1] = currentDetail.photoInfo["1"]?currentDetail.photoInfo["1"]:"images/empty.png";
        imgsrc[2] = currentDetail.photoInfo["2"]?currentDetail.photoInfo["2"]:"images/empty.png";
        imgsrc[3] = currentDetail.photoInfo["3"]?currentDetail.photoInfo["3"]:"images/empty.png";
        var photitle = new Array();
        photitle[0] = "Crash Scene";
        photitle[1] = "Your Car";
        photitle[2] = "Other Car";
        photitle[3] = "License Plate";
        
    	dom.byId("showimg").setAttribute("src", imgsrc[0]);
    	dom.byId("phoTitle").innerText = photitle[0];

        var i = 0;
        dom.byId("showimg").setAttribute("src", imgsrc[0]);
        dom.byId("next").onclick = function() {
            i++;
            if (i >= imgsrc.length) {
                i = 0;
            };
            dom.byId("showimg").setAttribute("src", imgsrc[i]);
            dom.byId("phoTitle").innerText = photitle[i];
        };
        dom.byId("pre").onclick = function() {
            i--;
            if (i < 0) {
                i = imgsrc.length - 1;
            };
            dom.byId("showimg").setAttribute("src", imgsrc[i]);
            dom.byId("phoTitle").innerText = photitle[i];
        };
    }

    return {init: dojo.getObject("mysurance.viewPhoto").init};
});