/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/**
* Load location from internal gps
* @param callback			Called with the discovered location
*/	
function getLocation(callback){	

	globalBusy = new WL.BusyIndicator('content', { text: 'Loading...'} );
	if(!globalBusy.isVisible()){
		globalBusy.show();
	}
	navigator.geolocation.getCurrentPosition(
		function(position){ //onSuccess
			globalBusy.hide();
			var loc = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
			WL.Logger.debug("geolocation_js.getLocation() location is "+loc);
			callback(loc);
		},
			
		function(){ //onFailure
			globalBusy.hide();
			WL.Logger.debug("index_html.getLocation() error retrieving current location. Using hardcoded location.");
			var loc = new google.maps.LatLng(36.175, -115.1363889); // Default to Las Vegas
			WL.Logger.debug("geolocation_js.getLocation() location is "+loc+" (hardcoded)");
			callback(loc);
		},
		{timeout: 10000, maximumAge: 30000,enableHighAccuracy:true}
	);
}

