/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

package com.ibm.impact.demo;

import java.util.HashSet;
import java.util.Set;

import javax.ws.rs.core.Application;

import org.codehaus.jackson.jaxrs.JacksonJaxbJsonProvider;

import com.ibm.impact.demo.services.AccidentDataService;
import com.ibm.impact.demo.services.MultiFileUploadDataService;
import com.ibm.impact.demo.services.ProfileDataService;

/**
 * This class is referenced by the web.xml and used to register the
 * JAX-RS services and providers used in this application.
 */
public class DemoApplicationRegistry extends Application {

	@Override
	public Set<Class<?>> getClasses() {
		Set<Class<?>> classes = new HashSet<Class<?>>();
		classes.add(JacksonJaxbJsonProvider.class);
		classes.add(MultiFileUploadDataService.class);
		classes.add(AccidentDataService.class);
		classes.add(ProfileDataService.class);
		return classes;
	}
}
