/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.impact.demo.services;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletConfig;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import com.ibm.impact.demo.beans.Accident;
import com.ibm.impact.demo.beans.AccidentRequest;



@Path("/accident")
public class AccidentDataService {
	
	static List<Accident> AccidentList = new ArrayList<Accident>();
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON)
	public String performAccident(AccidentRequest request,@Context ServletConfig servletConfig) {
		String response = "{status:'error',accId:-1}";
		try {
			Accident accident = new Accident(request.getId(),
					request.getUser(), request.getCrash(), request.getYcar(),
					request.getOcar(), request.getLicense());
			System.out.println("**************" + accident);
			for (Iterator<Accident> iter = AccidentList.iterator(); iter
					.hasNext();) {
				Accident tmp = (Accident) iter.next();
				if (tmp.getId() == accident.getId()) {
					iter.remove();
				}
			}
			AccidentList.add(accident);
			response = "{status:'success',accId:"+ request.getId() +"}";
		} catch (Exception e) {
			return response;
		}
		return response;
	}
	

	@GET
	@Produces(MediaType.APPLICATION_JSON)
	public List<Accident> getAllReports() {
		return AccidentList;
	}
	
}
