/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.impact.demo.services;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletConfig;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import com.ibm.impact.demo.beans.Photo;
import com.ibm.impact.demo.beans.PhotoRequest;



@Path("/photo")
public class PhotoDataService {
	
	static List<Photo> photoList = new ArrayList<Photo>();
	
	@POST
	@Consumes(MediaType.APPLICATION_JSON)
	public void performPhoto(PhotoRequest request,@Context ServletConfig servletConfig) {
		
		Photo photo = new Photo(request.getId(), request.getUser(), request.getComment());
		switch(request.getType())
		{
			case 0:
				photo.setType("Crash Scene");
				break;
			case 1:
				photo.setType("Your Car");
				break;
			case 2:
				photo.setType("Other Car");
				break;
			case 3:
				photo.setType("License Plate");
				break;
			default:
				photo.setType("Unknown Type");
		}
		
		for(Iterator<Photo> iter = photoList.iterator(); iter.hasNext();) {
			Photo tmp = (Photo) iter.next();
		    if(tmp.getId() == photo.getId()) {
		    	iter.remove();
		    }
		}
		photoList.add(photo);
	}
	

	@GET
	@Produces(MediaType.APPLICATION_JSON)
	public List<Photo> getAllReports() {
		return photoList;
	}
	
}
