/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*/

package com.ibm.impact.demo.services;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.ServletConfig;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

import com.ibm.impact.demo.beans.ProfileRequest;
import com.ibm.impact.demo.beans.Profile;
import com.ibm.impact.demo.beans.GetProfileRequest;



@Path("/profile")
public class ProfileDataService {
	
	static List<Profile> profileList = new ArrayList<Profile>();
	static{
		Profile profile1 = new Profile("001","demo","carlos","andreu","1978-03-14");
		profileList.add(profile1);
		Profile profile2 = new Profile("002","demo2","jeremy","nortey","1982-12-23");
		profileList.add(profile2);
	}
	
	@PUT
	@Path("/performProfile")
	@Consumes(MediaType.APPLICATION_JSON)
	public String performProfile(ProfileRequest request,@Context ServletConfig servletConfig) {
		String response = "{status:'error'}";
		try {
			Profile profile = new Profile(request.getId(),request.getUsername(),
					request.getFn(), request.getLn(), request.getBirthday());
			System.out.println("**************" + profile);
			for (Iterator<Profile> iter = profileList.iterator(); iter
					.hasNext();) {
				Profile tmp = (Profile) iter.next();
				if (tmp.getUsername().equals(profile.getUsername())) {
					iter.remove();
				}
			}
			profileList.add(profile);
			response = "{status:'success')";
		} catch (Exception e) {
			return response;
		}
		return response;
	}
	

	@GET
	@Path("/getAllProfile")
	@Produces(MediaType.APPLICATION_JSON)
	public List<Profile> getAllProfile() {
		return profileList;
	}
	
	@POST
	@Path("/getProfile")
	@Consumes(MediaType.APPLICATION_JSON)
	@Produces(MediaType.APPLICATION_JSON)
	public Profile getProfile(GetProfileRequest request,@Context ServletConfig servletConfig) {
		Profile response = null;
		try {
			for (Iterator<Profile> iter = profileList.iterator(); iter
					.hasNext();) {
				Profile tmp = (Profile) iter.next();
				if (tmp.getUsername().trim().equals(request.getUsername().trim())) {
					response = tmp;
					break;
				}
			}
		} catch (Exception e) {
			System.out.println(e.toString());
		}
		return response;
	}
	
}
